#pragma once

#include <boost/log/expressions.hpp>
#include <boost/log/utility/setup/common_attributes.hpp>
#include <boost/core/null_deleter.hpp>
#include <boost/log/sources/severity_logger.hpp>
#include <boost/log/sources/record_ostream.hpp>
#include <boost/log/sinks/sync_frontend.hpp>
#include <boost/log/sinks/text_ostream_backend.hpp>

#include <unordered_map>
#include <tuple>

#include <mutex> // for std::call_once
#include <atomic>

enum LogLevelEnum
{
	logDEBUG,
	logINFO,
	logWARNING,
	logERROR
};

extern boost::log::sources::severity_logger_mt<LogLevelEnum> slg_;
void Init();
void PrintLogLevel(LogLevelEnum level);
#define LOGMAN(level)  BOOST_LOG_STREAM_WITH_PARAMS((slg_), (::boost::log::keywords::severity = level))
